#ifndef _BN_H
#define _BN_H

/* Bignum functions */

typedef unsigned short *Bignum;

int ssh1_read_bignum(unsigned char *, Bignum *);
int ssh1_bignum_length(Bignum);
int ssh1_write_bignum(void *, Bignum);
Bignum modpow(Bignum, Bignum, Bignum);
Bignum modmul(Bignum, Bignum, Bignum);
Bignum bigmul(Bignum, Bignum);
Bignum bignum_from_bytes(unsigned char *, int);
Bignum copybn(Bignum);
int bignum_bitcount(Bignum);
int bignum_byte(Bignum, int);
int bignum_cmp(Bignum, Bignum);
void decbn(Bignum);
void freebn(Bignum);

#endif
