#ifndef _CIPHER_H
#define _CIPHER_H

/* Cipher functions */

typedef void (*SessKeyInitPtr)(unsigned char *);
typedef void (*CryptPtr)(unsigned char *, int);

void blowfish_sesskey(unsigned char *);
void blowfish_ssh1_encrypt_blk(unsigned char *, int);
void blowfish_ssh1_decrypt_blk(unsigned char *, int);

void des3_sesskey(unsigned char *);
void des3_encrypt_blk(unsigned char *, int);
void des3_decrypt_blk(unsigned char *, int);

void des3_decrypt_pubkey(unsigned char *, unsigned char *, int);


#endif
